#include "mpi.h"
#include "MPI_MPI.h"
#include <stdlib.h>

#define REF(x) (*(void**)&(unhand(unhand(this)->x)->handle))

char** sargs ;

long MPI_MPI_Init(struct HMPI_MPI *this, HArrayOfString *args) {
  int i, result, len ;
  HString **data = unhand(args)->body;
  len = obj_length(args);
  sargs = (char**)calloc(len, sizeof(char*));
  for (i=0; i<len; i++)
    sargs[i] = allocCString(data[i]);
  result = MPI_Init(&len, &sargs);
  return result;
}

long MPI_MPI_Finalize(struct HMPI_MPI *this) {
  return MPI_Finalize();
}

HString* MPI_MPI_Get_processor_name(struct HMPI_MPI *this) {
  int len;
  char processor_name[MPI_MAX_PROCESSOR_NAME];
  MPI_Get_processor_name(processor_name, &len);
  return makeJavaString(processor_name, len);
}

double MPI_MPI_Wtime(struct HMPI_MPI *this) {
  return MPI_Wtime();
}

double MPI_MPI_Wtick(struct HMPI_MPI *this) {
  return MPI_Wtick();
}

long MPI_MPI_Buffer_attach(struct HMPI_MPI *this,
  struct HArrayOfByte* buf) {
  return MPI_Buffer_attach(unhand(buf)->body, obj_length(buf));
}

long MPI_MPI_Buffer_detach(struct HMPI_MPI *this,
  struct HArrayOfByte* buf) {
  int size;
  return MPI_Buffer_detach(unhand(buf)->body, &size);
}

